% Example - Extrapolation: fixed point iteration on linear function
%   solve the equation x = Ax + b for random A and b

d = 10; n=20;
A = rand(d); b = rand(d,1); x_true = -(A - eye(d)) \ b;
X = b;
for i=1:n
    X(:,i+1) = A*X(:,i) + b;
end
F = X(:,2:end) - X(:,1:n);

x_out = ALGO_extrap_MPE_v1_20211022(F,X(:,1:n));
x = x_out(:,end);
Error_abs= norm(x - x_true)
Error_rel= Error_abs/norm(x_true)
Residual = norm(A*x + b - x)

Error_list = zeros(1,n);
for i=1:n
    Error_list(i) = norm(x_out(:,i) - x_true);
end

semilogy(1:n,Error_list,'b*--')